# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`nfs`](#nfs): Class: nfs::init  * {Please take a look at} [https://github.com/voxpupuli/puppet-nfs#examples]  * Daniel Klockenkaemper <mailto:dk@marketing-
* [`nfs::client`](#nfs--client): Class: nfs::client  This class exists to  1. order the loading of classes  2. including all needed classes for nfs as a client  * Daniel Kloc
* [`nfs::client::config`](#nfs--client--config): Class: nfs::client::config This Function exists to  1. configure nfs as a client  * Daniel Klockenkaemper <mailto:dk@marketing-factory.de> * 
* [`nfs::client::package`](#nfs--client--package): Class: nfs::client::package  This Function exists to  1. install needed packages for nfs clients  * Daniel Klockenkaemper <mailto:dk@marketin
* [`nfs::client::service`](#nfs--client--service): Class: nfs::client::service  This Function exists to  1. manage the needed services for nfs clients  * Daniel Klockenkaemper <mailto:dk@marke
* [`nfs::params`](#nfs--params): Class: nfs::params  This class exists to 1. Declutter the default value assignment for class parameters. 2. Manage internally used module var
* [`nfs::server`](#nfs--server): Class: nfs::server
* [`nfs::server::config`](#nfs--server--config): Class: nfs::server::config  This class exists to  1. configure nfs as a server  * Daniel Klockenkaemper <mailto:dk@marketing-factory.de> * Ma
* [`nfs::server::package`](#nfs--server--package): Class: nfs::server::package  This Function exists to  1. install needed packages for nfs server  * Daniel Klockenkaemper <mailto:dk@marketing
* [`nfs::server::service`](#nfs--server--service): Class: nfs::server::service  This Function exists to  1. manage the needed services for nfs server  * Daniel Klockenkaemper <mailto:dk@market

### Defined types

* [`nfs::client::mount`](#nfs--client--mount): Function: nfs::client::mount  This Function exists to  1. manage all mounts on a nfs client  Parameters  param nfs_v4   Boolean. When set to 
* [`nfs::functions::bindmount`](#nfs--functions--bindmount): Function: nfs::functions::bindmount  This Function exists to  1. manage bindmounts  * Daniel Klockenkaemper <mailto:dk@marketing-factory.de> 
* [`nfs::functions::create_export`](#nfs--functions--create_export): Function: nfs::functions::create_export  This Function exists to  1. manage export creation  * Daniel Klockenkaemper <mailto:dk@marketing-fac
* [`nfs::functions::mkdir`](#nfs--functions--mkdir): Function: nfs::functions::mkdir  This Function exists to  1. manage dir creation  * Daniel Klockenkaemper <mailto:dk@marketing-factory.de> * 
* [`nfs::functions::nfsv4_bindmount`](#nfs--functions--nfsv4_bindmount): Function: nfs::functions::nfsv4_bindmount  This Function exists to  1. manage bindmounts for nfs4  * Daniel Klockenkaemper <mailto:dk@marketi
* [`nfs::server::export`](#nfs--server--export): Function: nfs::server::export  This Function exists to  1. manage all exported resources on a nfs server  Parameters  class { '::nfs':   serv

## Classes

### <a name="nfs"></a>`nfs`

Class: nfs::init

* {Please take a look at} [https://github.com/voxpupuli/puppet-nfs#examples]

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

#### Parameters

The following parameters are available in the `nfs` class:

* [`ensure`](#-nfs--ensure)
* [`server_enabled`](#-nfs--server_enabled)
* [`client_enabled`](#-nfs--client_enabled)
* [`storeconfigs_enabled`](#-nfs--storeconfigs_enabled)
* [`nfs_v4`](#-nfs--nfs_v4)
* [`nfs_v4_client`](#-nfs--nfs_v4_client)
* [`exports_file`](#-nfs--exports_file)
* [`idmapd_file`](#-nfs--idmapd_file)
* [`defaults_file`](#-nfs--defaults_file)
* [`manage_packages`](#-nfs--manage_packages)
* [`server_packages`](#-nfs--server_packages)
* [`server_package_ensure`](#-nfs--server_package_ensure)
* [`client_packages`](#-nfs--client_packages)
* [`client_package_ensure`](#-nfs--client_package_ensure)
* [`manage_server_service`](#-nfs--manage_server_service)
* [`manage_server_servicehelper`](#-nfs--manage_server_servicehelper)
* [`manage_client_service`](#-nfs--manage_client_service)
* [`server_service_name`](#-nfs--server_service_name)
* [`server_service_ensure`](#-nfs--server_service_ensure)
* [`server_service_enable`](#-nfs--server_service_enable)
* [`server_service_hasrestart`](#-nfs--server_service_hasrestart)
* [`server_service_hasstatus`](#-nfs--server_service_hasstatus)
* [`server_service_restart_cmd`](#-nfs--server_service_restart_cmd)
* [`server_nfsv4_servicehelper`](#-nfs--server_nfsv4_servicehelper)
* [`client_services`](#-nfs--client_services)
* [`client_nfsv4_services`](#-nfs--client_nfsv4_services)
* [`client_services_enable`](#-nfs--client_services_enable)
* [`client_idmapd_setting`](#-nfs--client_idmapd_setting)
* [`client_nfs_fstype`](#-nfs--client_nfs_fstype)
* [`client_nfs_options`](#-nfs--client_nfs_options)
* [`client_nfsv4_fstype`](#-nfs--client_nfsv4_fstype)
* [`client_nfsv4_options`](#-nfs--client_nfsv4_options)
* [`nfs_v4_export_root`](#-nfs--nfs_v4_export_root)
* [`nfs_v4_export_root_clients`](#-nfs--nfs_v4_export_root_clients)
* [`nfs_v4_mount_root`](#-nfs--nfs_v4_mount_root)
* [`nfs_v4_idmap_domain`](#-nfs--nfs_v4_idmap_domain)
* [`nfsv4_bindmount_enable`](#-nfs--nfsv4_bindmount_enable)
* [`client_need_gssd`](#-nfs--client_need_gssd)
* [`client_gssd_service`](#-nfs--client_gssd_service)
* [`client_gssd_options`](#-nfs--client_gssd_options)
* [`client_d9_gssdopt_workaround`](#-nfs--client_d9_gssdopt_workaround)
* [`nfs_v4_idmap_localrealms`](#-nfs--nfs_v4_idmap_localrealms)
* [`nfs_v4_idmap_cache`](#-nfs--nfs_v4_idmap_cache)
* [`manage_nfs_v4_idmap_nobody_mapping`](#-nfs--manage_nfs_v4_idmap_nobody_mapping)
* [`nfs_v4_idmap_nobody_user`](#-nfs--nfs_v4_idmap_nobody_user)
* [`nfs_v4_idmap_nobody_group`](#-nfs--nfs_v4_idmap_nobody_group)
* [`client_rpcbind_config`](#-nfs--client_rpcbind_config)
* [`client_rpcbind_optname`](#-nfs--client_rpcbind_optname)
* [`client_rpcbind_opts`](#-nfs--client_rpcbind_opts)
* [`nfs_v4_root_export_ensure`](#-nfs--nfs_v4_root_export_ensure)
* [`nfs_v4_root_export_mount`](#-nfs--nfs_v4_root_export_mount)
* [`nfs_v4_root_export_remounts`](#-nfs--nfs_v4_root_export_remounts)
* [`nfs_v4_root_export_atboot`](#-nfs--nfs_v4_root_export_atboot)
* [`nfs_v4_root_export_options`](#-nfs--nfs_v4_root_export_options)
* [`nfs_v4_root_export_bindmount`](#-nfs--nfs_v4_root_export_bindmount)
* [`nfs_v4_root_export_tag`](#-nfs--nfs_v4_root_export_tag)
* [`client_gssd_service_name`](#-nfs--client_gssd_service_name)
* [`client_services_hasrestart`](#-nfs--client_services_hasrestart)
* [`client_services_hasstatus`](#-nfs--client_services_hasstatus)
* [`client_gssdopt_name`](#-nfs--client_gssdopt_name)

##### <a name="-nfs--ensure"></a>`ensure`

Data type: `Enum['present', 'absent', 'running', 'stopped', 'disabled']`

String. Controls if the managed resources shall be <tt>present</tt> or
<tt>absent</tt>. If set to <tt>absent</tt>:
* The managed software packages are being uninstalled.
* Any traces of the packages will be purged as good as possible. This may
  include existing configuration files. The exact behavior is provider
  dependent. Q.v.:
  * Puppet type reference: {package, "purgeable"}[http://j.mp/xbxmNP]
  * {Puppet's package provider source code}[http://j.mp/wtVCaL]
* System modifications (if any) will be reverted as good as possible
  (e.g. removal of created users, services, changed log settings, ...).
* This is thus destructive and should be used with care.
Defaults to <tt>present</tt>.

Default value: `'present'`

##### <a name="-nfs--server_enabled"></a>`server_enabled`

Data type: `Boolean`

Boolean. If set to <tt>true</tt>, this module will configure the node
to act as a nfs server.

Default value: `false`

##### <a name="-nfs--client_enabled"></a>`client_enabled`

Data type: `Boolean`

Boolean. If set to <tt>true</tt>, this module will configure the node
to act as a client server, you can use the exported mount resources
from configured servers.

Default value: `false`

##### <a name="-nfs--storeconfigs_enabled"></a>`storeconfigs_enabled`

Data type: `Boolean`

Boolean. If set to <tt>false</tt>, this module will not export any
resources as storeconfigs. Defaults to <tt>true</tt>.

Default value: `true`

##### <a name="-nfs--nfs_v4"></a>`nfs_v4`

Data type: `Boolean`

Boolean. If set to <tt>true</tt>, this module will use nfs version 4
for exporting and mounting nfs resources.

Default value: `false`

##### <a name="-nfs--nfs_v4_client"></a>`nfs_v4_client`

Data type: `Boolean`

Boolean. If set to <tt>true</tt>, this module will use nfs version 4
for mounting nfs resources. If set to <tt>false</tt> it will use nfs
version 3 to mount nfs resources. It defaults to the setting of @param nfs_v4

Default value: `false`

##### <a name="-nfs--exports_file"></a>`exports_file`

Data type: `Stdlib::Absolutepath`

String. It defines the location of file with the nfs export resources used
by the nfs server.

Default value: `$nfs::params::exports_file`

##### <a name="-nfs--idmapd_file"></a>`idmapd_file`

Data type: `Stdlib::Absolutepath`

String. It defines the location of the file with the idmapd settings.

Default value: `$nfs::params::idmapd_file`

##### <a name="-nfs--defaults_file"></a>`defaults_file`

Data type: `Optional[Stdlib::Absolutepath]`

String. It defines the location of the file with the nfs settings.

Default value: `$nfs::params::defaults_file`

##### <a name="-nfs--manage_packages"></a>`manage_packages`

Data type: `Boolean`

Boolean. It defines if the packages should be managed through this module

Default value: `true`

##### <a name="-nfs--server_packages"></a>`server_packages`

Data type: `Array`

Array. It defines the packages needed to be installed for acting as
a nfs server

Default value: `$nfs::params::server_packages`

##### <a name="-nfs--server_package_ensure"></a>`server_package_ensure`

Data type: `String`

String. It defines the packages state - any of present, installed,
absent, purged, held, latest

Default value: `'installed'`

##### <a name="-nfs--client_packages"></a>`client_packages`

Data type: `Array`

Array. It defines the packages needed to be installed for acting as
a nfs client

Default value: `$nfs::params::client_packages`

##### <a name="-nfs--client_package_ensure"></a>`client_package_ensure`

Data type: `String`

String. It defines the packages state - any of present, installed,
absent, purged, held, latest

Default value: `'installed'`

##### <a name="-nfs--manage_server_service"></a>`manage_server_service`

Data type: `Boolean`

Boolean. Defines if module should manage server_service

Default value: `true`

##### <a name="-nfs--manage_server_servicehelper"></a>`manage_server_servicehelper`

Data type: `Boolean`

Boolean. Defines if module should manage server_servicehelper

Default value: `true`

##### <a name="-nfs--manage_client_service"></a>`manage_client_service`

Data type: `Boolean`

Boolean. Defines if module should manage client_service

Default value: `true`

##### <a name="-nfs--server_service_name"></a>`server_service_name`

Data type: `String`

String. It defines the servicename of the nfs server service

Default value: `$nfs::params::server_service_name`

##### <a name="-nfs--server_service_ensure"></a>`server_service_ensure`

Data type: `Enum['present', 'absent', 'running', 'stopped', 'disabled']`

Boolean. It defines the service parameter ensure for nfs server services.

Default value: `'running'`

##### <a name="-nfs--server_service_enable"></a>`server_service_enable`

Data type: `Boolean`

Boolean. It defines the service parameter enable for nfs server service.

Default value: `true`

##### <a name="-nfs--server_service_hasrestart"></a>`server_service_hasrestart`

Data type: `Boolean`

Boolean. It defines the service parameter hasrestart for nfs server service.

Default value: `$nfs::params::server_service_hasrestart`

##### <a name="-nfs--server_service_hasstatus"></a>`server_service_hasstatus`

Data type: `Boolean`

Boolean. It defines the service parameter hasstatus for nfs server service.

Default value: `$nfs::params::server_service_hasstatus`

##### <a name="-nfs--server_service_restart_cmd"></a>`server_service_restart_cmd`

Data type: `Optional[String]`

String. It defines the service parameter restart for nfs server service.

Default value: `$nfs::params::server_service_restart_cmd`

##### <a name="-nfs--server_nfsv4_servicehelper"></a>`server_nfsv4_servicehelper`

Data type: `Optional[Array]`

Array. It defines the service helper like idmapd for servers configured with
nfs version 4.

Default value: `$nfs::params::server_nfsv4_servicehelper`

##### <a name="-nfs--client_services"></a>`client_services`

Data type: `Hash`

Nested Hash. It defines the servicenames need to be started when acting as a nfs client

Default value: `$nfs::params::client_services`

##### <a name="-nfs--client_nfsv4_services"></a>`client_nfsv4_services`

Data type: `Hash`

Nested Hash. It defines the servicenames need to be started when acting as a nfs client
version 4.

Default value: `$nfs::params::client_nfsv4_services`

##### <a name="-nfs--client_services_enable"></a>`client_services_enable`

Data type: `Boolean`

Boolean. It defines the service parameter enable for nfs client services.

Default value: `$nfs::params::client_services_enable`

##### <a name="-nfs--client_idmapd_setting"></a>`client_idmapd_setting`

Data type: `Array[String]`

Array. It defines the Augeas parameter added in @param defaults_file when acting as a nfs
version 4 client.

Default value: `$nfs::params::client_idmapd_setting`

##### <a name="-nfs--client_nfs_fstype"></a>`client_nfs_fstype`

Data type: `String`

String. It defines the name of the nfs filesystem, when adding entries to /etc/fstab
on a client node.

Default value: `$nfs::params::client_nfs_fstype`

##### <a name="-nfs--client_nfs_options"></a>`client_nfs_options`

Data type: `String`

String. It defines the options for the nfs filesystem, when adding entries to /etc/fstab
on a client node.

Default value: `$nfs::params::client_nfs_options`

##### <a name="-nfs--client_nfsv4_fstype"></a>`client_nfsv4_fstype`

Data type: `String`

String. It defines the name of the nfs version 4 filesystem, when adding entries
to /etc/fstab on a client node.

Default value: `$nfs::params::client_nfsv4_fstype`

##### <a name="-nfs--client_nfsv4_options"></a>`client_nfsv4_options`

Data type: `String`

String. It defines the options for the nfs version 4filesystem, when adding entries
to /etc/fstab on a client node.

Default value: `$nfs::params::client_nfsv4_options`

##### <a name="-nfs--nfs_v4_export_root"></a>`nfs_v4_export_root`

Data type: `String`

String. It defines the location where nfs version 4 exports should be bindmounted to
on a server node. Defaults to <tt>/export</tt>.

Default value: `'/export'`

##### <a name="-nfs--nfs_v4_export_root_clients"></a>`nfs_v4_export_root_clients`

Data type: `String`

String. It defines the clients that are allowed to mount nfs version 4 exports and
includes the option string. Defaults to
<tt>*.${::domain}(ro,fsid=root,insecure,no_subtree_check,async,root_squash)</tt>.

Default value: `"*.${facts['networking']['domain']}(ro,fsid=root,insecure,no_subtree_check,async,root_squash)"`

##### <a name="-nfs--nfs_v4_mount_root"></a>`nfs_v4_mount_root`

Data type: `String`

String. It defines the location where nfs version 4 clients find the mount root
on a server node. Defaults to <tt>/srv</tt>.

Default value: `'/srv'`

##### <a name="-nfs--nfs_v4_idmap_domain"></a>`nfs_v4_idmap_domain`

Data type: `String`

String. It defines the name of the idmapd domain setting in @param idmapd_file needed
to be set to the same value on a server and client node to do correct uid and gid
mapping. Defaults to <tt>$::domain</tt>.

Default value: `$nfs::params::nfs_v4_idmap_domain`

##### <a name="-nfs--nfsv4_bindmount_enable"></a>`nfsv4_bindmount_enable`

Data type: `Boolean`

Boolean. It defines if the module should create a bindmount for the export.
Defaults to <tt>true</tt>.

Default value: `true`

##### <a name="-nfs--client_need_gssd"></a>`client_need_gssd`

Data type: `Boolean`

Boolean. If true, sets NEED_GSSD=yes in /etc/defauls/nfs-common, usable on Debian/Ubuntu

Default value: `false`

##### <a name="-nfs--client_gssd_service"></a>`client_gssd_service`

Data type: `Boolean`

Boolean. If true enable rpc-gssd service.

Default value: `false`

##### <a name="-nfs--client_gssd_options"></a>`client_gssd_options`

Data type: `String`

String. Options for rpc-gssd service. Defaults to <tt>''</tt>

Default value: `$nfs::params::client_gssd_options`

##### <a name="-nfs--client_d9_gssdopt_workaround"></a>`client_d9_gssdopt_workaround`

Data type: `Boolean`

Boolean. If enabled, workaround for passing gssd_options which is broken on Debian 9. Usable only on Debian 9

Default value: `false`

##### <a name="-nfs--nfs_v4_idmap_localrealms"></a>`nfs_v4_idmap_localrealms`

Data type: `Variant[String, Array]`

String or Array. 'Local-Realms' option for idmapd. Defaults to <tt>''</tt>

Default value: `''`

##### <a name="-nfs--nfs_v4_idmap_cache"></a>`nfs_v4_idmap_cache`

Data type: `Integer`

Integer. 'Cache-Expiration' option for idmapd. Defaults to <tt>0</tt> - unused.

Default value: `0`

##### <a name="-nfs--manage_nfs_v4_idmap_nobody_mapping"></a>`manage_nfs_v4_idmap_nobody_mapping`

Data type: `Boolean`

Boolean. Enable setting Nobody mapping in idmapd. Defaults to <tt>false</tt>.

Default value: `false`

##### <a name="-nfs--nfs_v4_idmap_nobody_user"></a>`nfs_v4_idmap_nobody_user`

Data type: `String`

String. 'Nobody-User' option for idmapd. Defaults to <tt>nobody</tt>.

Default value: `$nfs::params::nfs_v4_idmap_nobody_user`

##### <a name="-nfs--nfs_v4_idmap_nobody_group"></a>`nfs_v4_idmap_nobody_group`

Data type: `String`

String. 'Nobody-Group' option for idmapd. Defaults to <tt>nobody</tt> or <tt>nogroup</tt>.

Default value: `$nfs::params::nfs_v4_idmap_nobody_group`

##### <a name="-nfs--client_rpcbind_config"></a>`client_rpcbind_config`

Data type: `Optional[Stdlib::Absolutepath]`

String. It defines the location of the file with the rpcbind config.

Default value: `$nfs::params::client_rpcbind_config`

##### <a name="-nfs--client_rpcbind_optname"></a>`client_rpcbind_optname`

Data type: `Optional[String]`

String. It defines the name of env variable that holds the rpcbind config. E.g. OPTIONS for Debian

Default value: `$nfs::params::client_rpcbind_optname`

##### <a name="-nfs--client_rpcbind_opts"></a>`client_rpcbind_opts`

Data type: `Optional[String]`

String. Options for rpcbind service.

Default value: `undef`

##### <a name="-nfs--nfs_v4_root_export_ensure"></a>`nfs_v4_root_export_ensure`

Data type: `String`

String. It defines the state of the nfs version 4 root export. Defaults to <tt>mounted</tt>.

Default value: `'mounted'`

##### <a name="-nfs--nfs_v4_root_export_mount"></a>`nfs_v4_root_export_mount`

Data type: `Optional[String]`

String. It defines the mountpoint of the nfs version 4 root export. Defaults to <tt>undef</tt>.

Default value: `undef`

##### <a name="-nfs--nfs_v4_root_export_remounts"></a>`nfs_v4_root_export_remounts`

Data type: `Boolean`

Boolean. It defines if the nfs version 4 root export should be remounted. Defaults to <tt>false</tt>.

Default value: `false`

##### <a name="-nfs--nfs_v4_root_export_atboot"></a>`nfs_v4_root_export_atboot`

Data type: `Boolean`

Boolean. It defines if the nfs version 4 root export should be mounted at boot. Defaults to <tt>false</tt>.

Default value: `false`

##### <a name="-nfs--nfs_v4_root_export_options"></a>`nfs_v4_root_export_options`

Data type: `String`

String. It defines the options for the nfs version 4 root export. Defaults to <tt>_netdev</tt>.

Default value: `'_netdev'`

##### <a name="-nfs--nfs_v4_root_export_bindmount"></a>`nfs_v4_root_export_bindmount`

Data type: `Optional[String]`

String. It defines the bindmount of the nfs version 4 root export. Defaults to <tt>undef</tt>.

Default value: `undef`

##### <a name="-nfs--nfs_v4_root_export_tag"></a>`nfs_v4_root_export_tag`

Data type: `Optional[String]`

String. It defines the tag of the nfs version 4 root export. Defaults to <tt>undef</tt>.

Default value: `undef`

##### <a name="-nfs--client_gssd_service_name"></a>`client_gssd_service_name`

Data type: `Optional[Hash]`

Hash. It defines the servicename of the rpc-gssd service.

Default value: `$nfs::params::client_gssd_service_name`

##### <a name="-nfs--client_services_hasrestart"></a>`client_services_hasrestart`

Data type: `Boolean`

Boolean. It defines the service parameter hasrestart for nfs client services.

Default value: `$nfs::params::client_services_hasrestart`

##### <a name="-nfs--client_services_hasstatus"></a>`client_services_hasstatus`

Data type: `Boolean`

Boolean. It defines the service parameter hasstatus for nfs client services.

Default value: `$nfs::params::client_services_hasstatus`

##### <a name="-nfs--client_gssdopt_name"></a>`client_gssdopt_name`

Data type: `String`

String. It defines the name of the gssd option in /etc/default/nfs-common.

Default value: `$nfs::params::client_gssdopt_name`

### <a name="nfs--client"></a>`nfs::client`

Class: nfs::client

This class exists to
 1. order the loading of classes
 2. including all needed classes for nfs as a client

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

#### Parameters

The following parameters are available in the `nfs::client` class:

* [`ensure`](#-nfs--client--ensure)
* [`nfs_v4`](#-nfs--client--nfs_v4)
* [`nfs_v4_mount_root`](#-nfs--client--nfs_v4_mount_root)
* [`nfs_v4_idmap_domain`](#-nfs--client--nfs_v4_idmap_domain)

##### <a name="-nfs--client--ensure"></a>`ensure`

Data type: `String`

The ensure parameter is used to determine if the nfs client should be configured
and running or not. Valid values are 'present' and 'absent'. Default is 'present'.

Default value: `$nfs::ensure`

##### <a name="-nfs--client--nfs_v4"></a>`nfs_v4`

Data type: `Boolean`

The nfs_v4 parameter is used to determine if the nfs client should use nfs version 4.
Valid values are 'true' and 'false'. Default is 'false'.

Default value: `$nfs::nfs_v4_client`

##### <a name="-nfs--client--nfs_v4_mount_root"></a>`nfs_v4_mount_root`

Data type: `String`

The nfs_v4_mount_root parameter is used to determine the root directory for nfs version 4 mounts.
Default is '/mnt'.

Default value: `$nfs::nfs_v4_mount_root`

##### <a name="-nfs--client--nfs_v4_idmap_domain"></a>`nfs_v4_idmap_domain`

Data type: `String`

The nfs_v4_idmap_domain parameter is used to determine the domain for nfs version 4 id mapping.
Default is 'localdomain'.

Default value: `$nfs::nfs_v4_idmap_domain`

### <a name="nfs--client--config"></a>`nfs::client::config`

Class: nfs::client::config
This Function exists to
 1. configure nfs as a client

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@betadots.de>

### <a name="nfs--client--package"></a>`nfs::client::package`

Class: nfs::client::package

This Function exists to
 1. install needed packages for nfs clients

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

### <a name="nfs--client--service"></a>`nfs::client::service`

Class: nfs::client::service

This Function exists to
 1. manage the needed services for nfs clients

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

### <a name="nfs--params"></a>`nfs::params`

Class: nfs::params

This class exists to
1. Declutter the default value assignment for class parameters.
2. Manage internally used module variables in a central place.

Therefore, many operating system dependent differences (names, paths, ...)
are addressed in here.

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

### <a name="nfs--server"></a>`nfs::server`

This class exists to
 1. order the loading of classes
 2. including all needed classes for nfs as a server

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <mailto:tuxmea@gmail.com>

#### Parameters

The following parameters are available in the `nfs::server` class:

* [`ensure`](#-nfs--server--ensure)
* [`nfs_v4`](#-nfs--server--nfs_v4)
* [`nfs_v4_export_root`](#-nfs--server--nfs_v4_export_root)
* [`nfs_v4_export_root_clients`](#-nfs--server--nfs_v4_export_root_clients)
* [`nfs_v4_idmap_domain`](#-nfs--server--nfs_v4_idmap_domain)
* [`nfs_v4_root_export_ensure`](#-nfs--server--nfs_v4_root_export_ensure)
* [`nfs_v4_root_export_mount`](#-nfs--server--nfs_v4_root_export_mount)
* [`nfs_v4_root_export_remounts`](#-nfs--server--nfs_v4_root_export_remounts)
* [`nfs_v4_root_export_atboot`](#-nfs--server--nfs_v4_root_export_atboot)
* [`nfs_v4_root_export_options`](#-nfs--server--nfs_v4_root_export_options)
* [`nfs_v4_root_export_bindmount`](#-nfs--server--nfs_v4_root_export_bindmount)
* [`nfs_v4_root_export_tag`](#-nfs--server--nfs_v4_root_export_tag)

##### <a name="-nfs--server--ensure"></a>`ensure`

Data type: `Enum['present', 'absent', 'running', 'stopped', 'disabled']`



Default value: `$nfs::ensure`

##### <a name="-nfs--server--nfs_v4"></a>`nfs_v4`

Data type: `Boolean`



Default value: `$nfs::nfs_v4`

##### <a name="-nfs--server--nfs_v4_export_root"></a>`nfs_v4_export_root`

Data type: `String`



Default value: `$nfs::nfs_v4_export_root`

##### <a name="-nfs--server--nfs_v4_export_root_clients"></a>`nfs_v4_export_root_clients`

Data type: `String`



Default value: `$nfs::nfs_v4_export_root_clients`

##### <a name="-nfs--server--nfs_v4_idmap_domain"></a>`nfs_v4_idmap_domain`

Data type: `String`



Default value: `$nfs::nfs_v4_idmap_domain`

##### <a name="-nfs--server--nfs_v4_root_export_ensure"></a>`nfs_v4_root_export_ensure`

Data type: `String`



Default value: `$nfs::nfs_v4_root_export_ensure`

##### <a name="-nfs--server--nfs_v4_root_export_mount"></a>`nfs_v4_root_export_mount`

Data type: `Optional[String]`



Default value: `$nfs::nfs_v4_root_export_mount`

##### <a name="-nfs--server--nfs_v4_root_export_remounts"></a>`nfs_v4_root_export_remounts`

Data type: `Boolean`



Default value: `$nfs::nfs_v4_root_export_remounts`

##### <a name="-nfs--server--nfs_v4_root_export_atboot"></a>`nfs_v4_root_export_atboot`

Data type: `Boolean`



Default value: `$nfs::nfs_v4_root_export_atboot`

##### <a name="-nfs--server--nfs_v4_root_export_options"></a>`nfs_v4_root_export_options`

Data type: `String`



Default value: `$nfs::nfs_v4_root_export_options`

##### <a name="-nfs--server--nfs_v4_root_export_bindmount"></a>`nfs_v4_root_export_bindmount`

Data type: `Optional[String]`



Default value: `$nfs::nfs_v4_root_export_bindmount`

##### <a name="-nfs--server--nfs_v4_root_export_tag"></a>`nfs_v4_root_export_tag`

Data type: `Optional[String]`



Default value: `$nfs::nfs_v4_root_export_tag`

### <a name="nfs--server--config"></a>`nfs::server::config`

Class: nfs::server::config

This class exists to
 1. configure nfs as a server

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

### <a name="nfs--server--package"></a>`nfs::server::package`

Class: nfs::server::package

This Function exists to
 1. install needed packages for nfs server

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

### <a name="nfs--server--service"></a>`nfs::server::service`

Class: nfs::server::service

This Function exists to
 1. manage the needed services for nfs server

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

## Defined types

### <a name="nfs--client--mount"></a>`nfs::client::mount`

Function: nfs::client::mount

This Function exists to
 1. manage all mounts on a nfs client

Parameters

param nfs_v4
  Boolean. When set to true, it uses nfs version 4 to mount a share.

class { '::nfs':
  client_enabled => true,
  nfs_v4_client  => true
}

nfs::client::mount { '/target/directory':
  server        => '1.2.3.4',
  share         => 'share_name_on_nfs_server',
  remounts      => true,
  atboot        => true,
  options_nfsv4 => 'tcp,nolock,rsize=32768,wsize=32768,intr,noatime,actimeo=3'
}

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

#### Parameters

The following parameters are available in the `nfs::client::mount` defined type:

* [`server`](#-nfs--client--mount--server)
* [`share`](#-nfs--client--mount--share)
* [`ensure`](#-nfs--client--mount--ensure)
* [`remounts`](#-nfs--client--mount--remounts)
* [`atboot`](#-nfs--client--mount--atboot)
* [`options_nfsv4`](#-nfs--client--mount--options_nfsv4)
* [`options_nfs`](#-nfs--client--mount--options_nfs)
* [`bindmount`](#-nfs--client--mount--bindmount)
* [`nfstag`](#-nfs--client--mount--nfstag)
* [`owner`](#-nfs--client--mount--owner)
* [`group`](#-nfs--client--mount--group)
* [`mode`](#-nfs--client--mount--mode)
* [`mount_root`](#-nfs--client--mount--mount_root)
* [`mount`](#-nfs--client--mount--mount)
* [`manage_packages`](#-nfs--client--mount--manage_packages)
* [`client_packages`](#-nfs--client--mount--client_packages)
* [`nfs_v4`](#-nfs--client--mount--nfs_v4)

##### <a name="-nfs--client--mount--server"></a>`server`

Data type: `String[1]`

String. Sets the ip address of the server with the nfs export

##### <a name="-nfs--client--mount--share"></a>`share`

Data type: `Optional[String[1]]`

String. Sets the name of the nfs share on the server

Default value: `undef`

##### <a name="-nfs--client--mount--ensure"></a>`ensure`

Data type: `String[1]`

String. Sets the ensure parameter of the mount.

Default value: `'mounted'`

##### <a name="-nfs--client--mount--remounts"></a>`remounts`

Data type: `Boolean`

String. Sets the remounts parameter of the mount.

Default value: `false`

##### <a name="-nfs--client--mount--atboot"></a>`atboot`

Data type: `Boolean`

String. Sets the atboot parameter of the mount.

Default value: `false`

##### <a name="-nfs--client--mount--options_nfsv4"></a>`options_nfsv4`

Data type: `String[1]`

String. Sets the mount options for a nfs version 4 mount.

Default value: `$nfs::client_nfsv4_options`

##### <a name="-nfs--client--mount--options_nfs"></a>`options_nfs`

Data type: `String[1]`

String. Sets the mount options for a nfs mount.

Default value: `$nfs::client_nfs_options`

##### <a name="-nfs--client--mount--bindmount"></a>`bindmount`

Data type: `Optional[String[1]]`

String. When not undef it will create a bindmount on the node
for the nfs mount.

Default value: `undef`

##### <a name="-nfs--client--mount--nfstag"></a>`nfstag`

Data type: `Optional[String[1]]`

String. Sets the nfstag parameter of the mount.

Default value: `undef`

##### <a name="-nfs--client--mount--owner"></a>`owner`

Data type: `Optional[String[1]]`

String. Set owner of mount dir

Default value: `undef`

##### <a name="-nfs--client--mount--group"></a>`group`

Data type: `Optional[String[1]]`

String. Set group of mount dir

Default value: `undef`

##### <a name="-nfs--client--mount--mode"></a>`mode`

Data type: `Optional[String[1]]`

String. Set mode of mount dir

Default value: `undef`

##### <a name="-nfs--client--mount--mount_root"></a>`mount_root`

Data type: `Optional[String[1]]`

String. Overwrite mount root if differs from server config

Default value: `undef`

##### <a name="-nfs--client--mount--mount"></a>`mount`

Data type: `String[1]`



Default value: `$title`

##### <a name="-nfs--client--mount--manage_packages"></a>`manage_packages`

Data type: `Boolean`



Default value: `$nfs::manage_packages`

##### <a name="-nfs--client--mount--client_packages"></a>`client_packages`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `$nfs::effective_client_packages`

##### <a name="-nfs--client--mount--nfs_v4"></a>`nfs_v4`

Data type: `Boolean`



Default value: `$nfs::client::nfs_v4`

### <a name="nfs--functions--bindmount"></a>`nfs::functions::bindmount`

Function: nfs::functions::bindmount

This Function exists to
 1. manage bindmounts

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

#### Parameters

The following parameters are available in the `nfs::functions::bindmount` defined type:

* [`mount_name`](#-nfs--functions--bindmount--mount_name)
* [`ensure`](#-nfs--functions--bindmount--ensure)

##### <a name="-nfs--functions--bindmount--mount_name"></a>`mount_name`

Data type: `Optional[String[1]]`

String. Sets the target directory for the bindmount

Default value: `undef`

##### <a name="-nfs--functions--bindmount--ensure"></a>`ensure`

Data type: `String[1]`

String. Sets if enabled or not.

Default value: `'present'`

### <a name="nfs--functions--create_export"></a>`nfs::functions::create_export`

Function: nfs::functions::create_export

This Function exists to
 1. manage export creation

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

#### Parameters

The following parameters are available in the `nfs::functions::create_export` defined type:

* [`clients`](#-nfs--functions--create_export--clients)
* [`ensure`](#-nfs--functions--create_export--ensure)
* [`owner`](#-nfs--functions--create_export--owner)
* [`group`](#-nfs--functions--create_export--group)
* [`mode`](#-nfs--functions--create_export--mode)

##### <a name="-nfs--functions--create_export--clients"></a>`clients`

Data type: `Variant[String[1], Array[String[1]]]`

String or Array. Sets the clients allowed to mount the export with options.

##### <a name="-nfs--functions--create_export--ensure"></a>`ensure`

Data type: `String[1]`

String. Sets if enabled or not.

Default value: `'present'`

##### <a name="-nfs--functions--create_export--owner"></a>`owner`

Data type: `Optional[String[1]]`

String. Sets the owner of the exported directory.

Default value: `undef`

##### <a name="-nfs--functions--create_export--group"></a>`group`

Data type: `Optional[String[1]]`

String. Sets the group of the exported directory.

Default value: `undef`

##### <a name="-nfs--functions--create_export--mode"></a>`mode`

Data type: `Optional[String[1]]`

String. Sets the permissions of the exported directory.

Default value: `undef`

### <a name="nfs--functions--mkdir"></a>`nfs::functions::mkdir`

Function: nfs::functions::mkdir

This Function exists to
 1. manage dir creation

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

#### Parameters

The following parameters are available in the `nfs::functions::mkdir` defined type:

* [`ensure`](#-nfs--functions--mkdir--ensure)

##### <a name="-nfs--functions--mkdir--ensure"></a>`ensure`

Data type: `String[1]`



Default value: `'present'`

### <a name="nfs--functions--nfsv4_bindmount"></a>`nfs::functions::nfsv4_bindmount`

Function: nfs::functions::nfsv4_bindmount

This Function exists to
 1. manage bindmounts for nfs4

* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <tuxmea@gmail.com>

#### Parameters

The following parameters are available in the `nfs::functions::nfsv4_bindmount` defined type:

* [`v4_export_name`](#-nfs--functions--nfsv4_bindmount--v4_export_name)
* [`bind`](#-nfs--functions--nfsv4_bindmount--bind)
* [`ensure`](#-nfs--functions--nfsv4_bindmount--ensure)

##### <a name="-nfs--functions--nfsv4_bindmount--v4_export_name"></a>`v4_export_name`

Data type: `String[1]`

String. Sets the target directory for the bindmount

##### <a name="-nfs--functions--nfsv4_bindmount--bind"></a>`bind`

Data type: `String[1]`

String. Sets the bindmount options.

##### <a name="-nfs--functions--nfsv4_bindmount--ensure"></a>`ensure`

Data type: `String[1]`

String. Sets if mounted or not.

Default value: `'mounted'`

### <a name="nfs--server--export"></a>`nfs::server::export`

Function: nfs::server::export

This Function exists to
 1. manage all exported resources on a nfs server

Parameters

class { '::nfs':
  server_enabled             => true,
  nfs_v4                     => true,
  nfs_v4_export_root         => '/share',
  nfs_v4_export_root_clients => '1.2.3.4/24(rw,fsid=root,insecure,no_subtree_check,async,no_root_squash)',
}

nfs::server::export { '/srv/nfs_exported/directory':
  clients => '1.2.3.4/24(rw,insecure,no_subtree_check,async,no_root_squash) 5.6.7.8/24(ro)',
  share => 'share_name_on_nfs_server',
}

Links

* {Puppet Docs: Using Parameterized Classes}[http://j.mp/nVpyWY]


* Daniel Klockenkaemper <mailto:dk@marketing-factory.de>
* Martin Alfke <mailto:tuxmea@gmail.com>

#### Parameters

The following parameters are available in the `nfs::server::export` defined type:

* [`clients`](#-nfs--server--export--clients)
* [`bind`](#-nfs--server--export--bind)
* [`ensure`](#-nfs--server--export--ensure)
* [`remounts`](#-nfs--server--export--remounts)
* [`atboot`](#-nfs--server--export--atboot)
* [`options_nfsv4`](#-nfs--server--export--options_nfsv4)
* [`options_nfs`](#-nfs--server--export--options_nfs)
* [`bindmount`](#-nfs--server--export--bindmount)
* [`nfstag`](#-nfs--server--export--nfstag)
* [`mount`](#-nfs--server--export--mount)
* [`owner`](#-nfs--server--export--owner)
* [`group`](#-nfs--server--export--group)
* [`mode`](#-nfs--server--export--mode)
* [`server`](#-nfs--server--export--server)
* [`v3_export_name`](#-nfs--server--export--v3_export_name)
* [`v4_export_name`](#-nfs--server--export--v4_export_name)
* [`nfsv4_bindmount_enable`](#-nfs--server--export--nfsv4_bindmount_enable)

##### <a name="-nfs--server--export--clients"></a>`clients`

Data type: `String[1]`

String or Array. Sets the allowed clients and options for the export in the exports file.
Defaults to <tt>localhost(ro)</tt>

Default value: `'localhost(ro)'`

##### <a name="-nfs--server--export--bind"></a>`bind`

Data type: `String[1]`

String. Sets the bind options setted in /etc/fstab for the bindmounts created.
Defaults to <tt>rbind</tt>

Default value: `'rbind'`

##### <a name="-nfs--server--export--ensure"></a>`ensure`

Data type: `String[1]`

String. If enabled the mount will be created. Defaults to <tt>mounted</tt>

Default value: `'mounted'`

##### <a name="-nfs--server--export--remounts"></a>`remounts`

Data type: `Boolean`

String. Sets the remounts parameter of the mount.

Default value: `false`

##### <a name="-nfs--server--export--atboot"></a>`atboot`

Data type: `Boolean`

String. Sets the atboot parameter of the mount.

Default value: `false`

##### <a name="-nfs--server--export--options_nfsv4"></a>`options_nfsv4`

Data type: `String[1]`

String. Sets the mount options for a nfs version 4 exported resource mount.

Default value: `$nfs::client_nfsv4_options`

##### <a name="-nfs--server--export--options_nfs"></a>`options_nfs`

Data type: `String[1]`

String. Sets the mount options for a nfs exported resource mount.

Default value: `$nfs::client_nfs_options`

##### <a name="-nfs--server--export--bindmount"></a>`bindmount`

Data type: `Optional[String[1]]`

String. When not undef it will create a bindmount on the node
for the nfs mount.

Default value: `undef`

##### <a name="-nfs--server--export--nfstag"></a>`nfstag`

Data type: `Optional[String[1]]`

String. Sets the nfstag parameter of the mount.

Default value: `undef`

##### <a name="-nfs--server--export--mount"></a>`mount`

Data type: `Optional[String[1]]`

String. Sets the mountpoint the client will mount the exported resource mount on. If undef
it defaults to the same path as on the server

Default value: `undef`

##### <a name="-nfs--server--export--owner"></a>`owner`

Data type: `Optional[String[1]]`

String. Sets the owner of the exported directory

Default value: `undef`

##### <a name="-nfs--server--export--group"></a>`group`

Data type: `Optional[String[1]]`

String. Sets the group of the exported directory

Default value: `undef`

##### <a name="-nfs--server--export--mode"></a>`mode`

Data type: `Optional[String[1]]`

String. Sets the permissions of the exported directory.

Default value: `undef`

##### <a name="-nfs--server--export--server"></a>`server`

Data type: `String[1]`

String. Sets the hostname clients will use to mount the exported resource. If undef it
defaults to the trusted certname

Default value: `$facts['clientcert']`

##### <a name="-nfs--server--export--v3_export_name"></a>`v3_export_name`

Data type: `String[1]`



Default value: `$name`

##### <a name="-nfs--server--export--v4_export_name"></a>`v4_export_name`

Data type: `String[1]`



Default value: `regsubst($name, '.*/(.*)', '\1' )`

##### <a name="-nfs--server--export--nfsv4_bindmount_enable"></a>`nfsv4_bindmount_enable`

Data type: `Boolean`



Default value: `$nfs::nfsv4_bindmount_enable`

